' QBasic Keyboard Interrupt Handler
' by Gary Neal, Jr.  ----  [garyneal_71@yahoo.com]
'
' Illustrates the use of assembly language to write a low-level
' keyboard handler for the QBasic platform.
'
' This code may run under QuickBASIC, though not recommended.
' For more info, visit my web page at:
'     http://www.geocities.com/SiliconValley/Park/7113/
'

' Keyboard handler functions.
DECLARE SUB InstallKeyISR ALIAS "INSTALLKEYISR" ()
DECLARE SUB RemoveKeyISR ALIAS "REMOVEKEYISR" ()
DECLARE SUB InitKeyISR ALIAS "INITKEYISR" ()
DECLARE FUNCTION KeyPressed% ALIAS "KEYPRESSED" (BYVAL scanCode AS INTEGER)
DECLARE FUNCTION KeyPressedNow% ALIAS "KEYPRESSEDNOW" (BYVAL scanCode AS INTEGER)

' Variables for use with the test program.
DIM X AS INTEGER
DIM Y AS INTEGER
DIM delay AS LONG
DIM myCount AS LONG

Start:
'X = KeyPressed%(1)
'Y = KeyPressed%(80)
'PRINT X, Y
InitKeyISR
'X = KeyPressed%(1)
'Y = KeyPressed%(80)
'PRINT X, Y
'END

' Initialize screen for testing.
SCREEN 13
X = 160
Y = 100
PSET (X, Y), 15

WHILE INKEY$ <> "": WEND         ' Clear the keyboard
WHILE INKEY$ = "": WEND          ' Wait for a key
WHILE INKEY$ <> "": WEND         ' Clear the keyboard
myCount = 10

' Replace BIOS's Keyboard handler with our own.
InstallKeyISR

' Main Testing Loop
DO UNTIL KeyPressed%(1) OR myCount = 0 ' Press ESC key to exit
    PSET (X, Y), 0                    ' Erase pixel

    ' Test whether player wants to move up or down.
    IF KeyPressedNow%(72) THEN        ' Up Arrow Moves Dot Up
        Y = Y - 1                     ' Subtract one from Y-coordinate
        IF Y < 0 THEN Y = 0           ' Y-coordinate is never < 0
    ELSEIF KeyPressedNow%(80) THEN    ' Down Arrow Moves Dot Down
        Y = Y + 1                     ' Add one to Y-coordinate
        IF Y > 199 THEN Y = 199       ' Y-coordinate is never > 199
    END IF

    ' Test whether player wants to move left or right.
    IF KeyPressedNow%(75) THEN        ' Left Arrow Moves Dot Left
        X = X - 1                     ' Subtract one from X-coordinate.
        IF X < 0 THEN X = 0           ' X-coodinate is never < 0
    ELSEIF KeyPressedNow%(77) THEN    ' Right Arrow Moves Dot Right
        X = X + 1                     ' Add one to X-coordinate
        IF X > 319 THEN X = 319       ' X-coordinate is never > 319
    END IF
    PSET (X, Y), 15                   ' Redraw pixel in new position

    ' Delay program.
    ' Change the 2000 to change the speed.
    FOR delay = 1 TO 2000: NEXT delay
LOOP

' Restore BIOS's keyboard handler
RemoveKeyISR

' Restore the text screen.
SCREEN 0
WIDTH 80, 25

' Play again?
INPUT "Again (Y/N)"; A$
IF INSTR(UCASE$(A$), "Y") GOTO Start

' If not, clear the keyboard and exit.
WHILE INKEY$ <> "": WEND
END

