TYPE PCXHeader
    manufacturer AS STRING * 1
    version AS STRING * 1
    encoding AS STRING * 1
    bitsPerPixel AS STRING * 1
    xMin AS INTEGER
    yMin AS INTEGER
    xMax AS INTEGER
    yMax AS INTEGER
    horizRes AS INTEGER
    vertRes AS INTEGER
    egaPalette AS STRING * 48
    reserved AS STRING * 1
    numOfPlanes AS STRING * 1
    bytesPerLine AS INTEGER
    paletteType AS INTEGER
    hScreenSize AS INTEGER
    vScreenSize AS INTEGER
    filler AS STRING * 54
END TYPE

TYPE ColorAttributes
    Red AS INTEGER
    Green AS INTEGER
    Blue AS INTEGER
END TYPE

DIM Header AS PCXHeader
DIM myByte AS STRING * 1
DIM myColor AS ColorAttributes

PRINT LEN(Header)

Header.manufacturer = CHR$(10)
Header.version = CHR$(5)
Header.encoding = CHR$(1)
Header.bitsPerPixel = CHR$(8)
Header.xMin = 0
Header.yMin = 0
Header.xMax = 319
Header.yMax = 199
Header.horizRes = 320
Header.vertRes = 200
Header.reserved = CHR$(0)
Header.numOfPlanes = CHR$(1)
Header.bytesPerLine = 320
Header.paletteType = 1
Header.hScreenSize = 320
Header.vScreenSize = 200
Header.filler = "Created by Gary Neal Jr's Picture class written 1999"

SCREEN 13
RANDOMIZE TIMER

FOR x% = 1 TO 50
    PSET (RND * 320, RND * 200), RND * 256
    LINE (RND * 320, RND * 200)-(RND * 320, RND * 200), RND * 256
    CIRCLE (RND * 320, RND * 200), RND * 25, RND * 256
NEXT x%

LOCATE 22, 2
PRINT "Created using the TESTPCX.BAS program"
LOCATE , 9
PRINT "written by Gary Neal, Jr."

WHILE INKEY$ <> "": WEND
WHILE INKEY$ = "": WEND

ON ERROR GOTO ErrorTrap
KILL "testfile.pcx"

WriteFile:
ON ERROR GOTO 0
OPEN "testfile.pcx" FOR BINARY ACCESS WRITE AS #1

PUT #1, , Header

FOR row% = 0 TO 199
    count% = 0

    FOR col% = 0 TO 319
        IF col% = 0 THEN myData% = POINT(col%, row%)
        IF myData% = POINT(col%, row%) THEN
            count% = count% + 1
            IF count% = 63 THEN
                myByte = CHR$(count% OR &HC0)
                PUT #1, , myByte
                myByte = CHR$(myData%)
                PUT #1, , myByte
                count% = 0
            END IF
        ELSE
            IF count% = 0 THEN
                count% = 1
                myData% = POINT(col%, row%)
            ELSEIF count% > 1 THEN
                myByte = CHR$(count% OR &HC0)
                PUT #1, , myByte
                myByte = CHR$(myData%)
                PUT #1, , myByte
                count% = 1
                myData% = POINT(col%, row%)
            ELSEIF (myData% AND 192) = 192 THEN
                myByte = CHR$(count% OR &HC0)
                PUT #1, , myByte
                myByte = CHR$(myData%)
                PUT #1, , myByte
                count% = 1
                myData% = POINT(col%, row%)
            ELSE
                myByte = CHR$(myData%)
                PUT #1, , myByte
                count% = 1
                myData% = POINT(col%, row%)
            END IF
        END IF
    NEXT col%

    IF count% > 0 THEN
        IF count% > 1 THEN
            myByte = CHR$(count% OR &HC0)
            PUT #1, , myByte
            myByte = CHR$(myData%)
            PUT #1, , myByte
        ELSEIF (myData% AND &HC0) = &HC0 THEN
            myByte = CHR$(count% OR &HC0)
            PUT #1, , myByte
            myByte = CHR$(myData%)
            PUT #1, , myByte
        ELSE
            myByte = CHR$(myData%)
            PUT #1, , myByte
        END IF
    END IF
NEXT row%

myByte = CHR$(12)
PUT #1, , myByte

FOR x% = 0 TO 255
    OUT &H3C6, &HFF
    OUT &H3C7, x%
    myColor.Red = INP(&H3C9)
    myColor.Green = INP(&H3C9)
    myColor.Blue = INP(&H3C9)

    IF myColor.Red > 0 THEN
        myByte = CHR$((myColor.Red * 4) OR 3)
    ELSE
        myByte = CHR$(myColor.Red * 4)
    END IF
    PUT #1, , myByte

    IF myColor.Green > 0 THEN
        myByte = CHR$((myColor.Green * 4) OR 3)
    ELSE
        myByte = CHR$(myColor.Green * 4)
    END IF
    PUT #1, , myByte

    IF myColor.Blue > 0 THEN
        myByte = CHR$((myColor.Blue * 4) OR 3)
    ELSE
        myByte = CHR$(myColor.Blue * 4)
    END IF
    PUT #1, , myByte
NEXT x%

CLOSE #1
SCREEN 0
WIDTH 80
END

ErrorTrap:
    RESUME WriteFile

